// WLServerDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "WLServer.h"
#include "WLServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
const int _tDevID[]={-1, 0, 1, 2, 3, 4, 0x80000000};
const int _tFIFO[]={4, 8, 12, 16, 24, 32, 0x80000000};
const LPCSTR _tPORT[]={
	"NONE", "COM1", "COM2", "COM3", "COM4", "COM5", "COM6", "COM7", "COM8", NULL
};

int IndexOf(const int *pTbl, int d)
{
	for( int i = 0; *pTbl != 0x80000000; i++, pTbl++ ){
		if( *pTbl == d ) return i;
	}
	return 0;
}
int IndexOf(const LPCSTR *pTbl, LPCSTR pKey)
{
	for( int i = 0; *pTbl != NULL; i++, pTbl++ ){
		if( !strcmpi(*pTbl, pKey) ) return i;
	}
	return 0;
}
void AddComboItem(CComboBox *pBox, const int *pTbl)
{
	char bf[32];
	while(*pTbl!=0x80000000){
		wsprintf(bf, "%d", *pTbl++);
		pBox->AddString(bf);
	}
}
void AddComboItem(CComboBox *pBox, const LPCSTR *pTbl)
{
	while(*pTbl){
		pBox->AddString(*pTbl++);
	}
}
/////////////////////////////////////////////////////////////////////////////
// CWLServerDlg _CAO

CWLServerDlg::CWLServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWLServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWLServerDlg)
	m_DlgDevID = -1;
	m_DlgRXFIFO = -1;
	m_DlgTXFIFO = -1;
	m_DlgChannel = -1;
	m_DlgDTR = FALSE;
	m_DlgRTS = FALSE;
	m_DlgPort = -1;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_hPort = INVALID_HANDLE_VALUE;
	m_pSocket = NULL;
	m_Connection.RemoveAll();
	m_PortTCP = 10203;
	memset(&m_OutData, 0, sizeof(m_OutData));
    memset(&m_InData, 0, sizeof(m_InData));
	m_SoundPara.m_ID = -1;
	m_SoundPara.m_TxFifo = 12;
	m_SoundPara.m_RxFifo = 12;
	m_SoundPara.m_Channel = 0;
	m_InStatus = m_OutStatus = -1;
	m_Wave.m_InFifoSize = m_SoundPara.m_RxFifo;
	m_Wave.m_OutFifoSize = m_SoundPara.m_TxFifo;
	m_Wave.m_SoundStereo = m_SoundPara.m_Channel;
	m_ptt = 0;
}

void CWLServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWLServerDlg)
	DDX_Control(pDX, IDC_MINIMIZE, m_DlgMinimized);
	DDX_CBIndex(pDX, IDC_DevID, m_DlgDevID);
	DDX_CBIndex(pDX, IDC_RXFIFO, m_DlgRXFIFO);
	DDX_CBIndex(pDX, IDC_TXFIFO, m_DlgTXFIFO);
	DDX_Radio(pDX, IDC_RMONO, m_DlgChannel);
	DDX_Check(pDX, IDC_DTR, m_DlgDTR);
	DDX_Check(pDX, IDC_RTS, m_DlgRTS);
	DDX_CBIndex(pDX, IDC_PORT, m_DlgPort);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_BTX, m_tbDlgTX);
	DDX_Control(pDX, IDC_NSTATUS, m_csDlgNStatus);
	DDX_Control(pDX, IDC_SDEVID, m_csDlgDevID);
	DDX_Control(pDX, IDC_STXFIFO, m_csDlgTX);
	DDX_Control(pDX, IDC_SRXFIFO, m_csDlgRX);
	DDX_Control(pDX, IDC_SPORT, m_csDlgPort);
}

BEGIN_MESSAGE_MAP(CWLServerDlg, CDialog)
	//{{AFX_MSG_MAP(CWLServerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_DevID, OnSelchangeDevID)
	ON_CBN_SELCHANGE(IDC_RXFIFO, OnSelchangeRxfifo)
	ON_CBN_SELCHANGE(IDC_TXFIFO, OnSelchangeTxfifo)
	ON_BN_CLICKED(IDC_RMONO, OnRmono)
	ON_BN_CLICKED(IDC_RLEFT, OnRleft)
	ON_BN_CLICKED(IDC_RRIGHT, OnRright)
	ON_BN_CLICKED(IDC_DTR, OnDtr)
	ON_BN_CLICKED(IDC_RTS, OnRts)
	ON_BN_CLICKED(IDC_BTX, OnBtx)
	ON_CBN_SELCHANGE(IDC_PORT, OnSelchangePort)
	ON_WM_SYSCOMMAND()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_MINIMIZE, OnMinimize)
	//}}AFX_MSG_MAP
    ON_MESSAGE(WM_WAVE, OnWaveEvent)
    ON_MESSAGE(WM_SOCKETEVENT, OnSocketEvent)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWLServerDlg bZ[W nh

BOOL CWLServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	m_tbDlgTX.SetTextColor(RGB(255,0,0));
	m_Wave.m_hWnd = m_hWnd;

	CWLServerApp *pApp = GetApp(); 
	ASSERT(pApp);
	pApp->RegisterMainWindow(m_hWnd);

	m_PortTCP = pApp->GetProfileInt("TCP", "Port", m_PortTCP);

	m_pSocket = new CLSocket(this);
	ASSERT(m_pSocket);
	if( !m_pSocket->Create(m_PortTCP) || !m_pSocket->Listen() ){
		delete m_pSocket;
		m_pSocket = NULL;
	}
	AddComboItem((CComboBox *)GetDlgItem(IDC_DevID), _tDevID);
	AddComboItem((CComboBox *)GetDlgItem(IDC_RXFIFO), _tFIFO);
	AddComboItem((CComboBox *)GetDlgItem(IDC_TXFIFO), _tFIFO);
	AddComboItem((CComboBox *)GetDlgItem(IDC_PORT), _tPORT);

	m_SoundPara.m_ID = pApp->GetProfileInt("Sound", "ID", m_SoundPara.m_ID);
	m_SoundPara.m_TxFifo = pApp->GetProfileInt("Sound", "TXFIFO", m_SoundPara.m_TxFifo);
	m_SoundPara.m_RxFifo = pApp->GetProfileInt("Sound", "RXFIFO", m_SoundPara.m_RxFifo);
	m_SoundPara.m_Channel = pApp->GetProfileInt("Sound", "Channel", m_SoundPara.m_Channel);

	CString cs = pApp->GetProfileString("Port", "Name", "NONE");
	m_DlgPort = IndexOf(_tPORT, cs);
	DWORD dw = pApp->GetProfileInt("Port", "PTT", 3);
	m_DlgDTR = dw & 1;
	m_DlgRTS = dw & 2;
	RECT rc;
	rc.left = pApp->GetProfileInt("Window", "Left", 100);
	rc.top = pApp->GetProfileInt("Window", "Top", 50);
	int iconic = pApp->GetProfileInt("Window", "Minimized", FALSE);
	m_DlgMinimized.SetCheck(iconic);
	if( rc.left < -200 ) rc.left = 0;
	if( rc.top < -100 ) rc.top = 0;
	::SetWindowPos(m_hWnd, HWND_TOPMOST, rc.left, rc.top, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
	ShowWindow(iconic ? SW_MINIMIZE : SW_SHOW);

	m_DlgDevID = IndexOf(_tDevID, m_SoundPara.m_ID);
	m_DlgTXFIFO = IndexOf(_tFIFO, m_SoundPara.m_TxFifo);
	m_DlgRXFIFO = IndexOf(_tFIFO, m_SoundPara.m_RxFifo);
	m_DlgChannel = m_SoundPara.m_Channel;

	UpdateData(FALSE);
	DispStatus();
	OpenPort();
	DispSoundStat();
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

//---------------------------------------------------------------------------
BOOL CWLServerDlg::DestroyWindow() 
{
	m_Wave.OutAbort();
	m_Wave.InClose();
	if( m_pSocket ){
		delete m_pSocket;
		m_pSocket = NULL;
	}
	POSITION pos;
	for( pos = m_Connection.GetHeadPosition(); pos != NULL; ){
		CCSocket *pSocket = (CCSocket*)m_Connection.GetNext(pos);
		pSocket->EnableEvent(FALSE);
		pSocket->Close();
		delete pSocket;
	}
	m_Connection.RemoveAll();
	ClosePort();

	CWinApp *pApp = AfxGetApp(); 
	pApp->WriteProfileInt("TCP", "Port", m_PortTCP);

	pApp->WriteProfileInt("Sound", "ID", m_SoundPara.m_ID);
	pApp->WriteProfileInt("Sound", "TXFIFO", m_SoundPara.m_TxFifo);
	pApp->WriteProfileInt("Sound", "RXFIFO", m_SoundPara.m_RxFifo);
	pApp->WriteProfileInt("Sound", "Channel", m_SoundPara.m_Channel);

	pApp->WriteProfileString("Port", "Name", _tPORT[m_DlgPort]);
	pApp->WriteProfileInt("Port", "PTT", (m_DlgRTS << 1) | m_DlgDTR);
	int iconic = IsIconic();
	if( !iconic ){
		RECT rc;
		GetWindowRect(&rc);
		pApp->WriteProfileInt("Window", "Left", rc.left);
		pApp->WriteProfileInt("Window", "Top", rc.top);
	}
	pApp->WriteProfileInt("Window", "Minimized", m_DlgMinimized.GetCheck());

	return CDialog::DestroyWindow();
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CWLServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CWLServerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//---------------------------------------------------------------------------
void CWLServerDlg::OnAccept(int nErrorCode)
{
	ASSERT(m_pSocket);
	if( !m_pSocket ) return;

	CCSocket* pSocket = new CCSocket(this);

	if(m_pSocket->Accept(*pSocket)){
		m_Connection.AddTail(pSocket);
		PostMessage(WM_SOCKETEVENT, MMSO_STATUS, 0);
	}
	else {
		delete pSocket;
	}
}
//---------------------------------------------------------------------------
void CWLServerDlg::OnReceive(CCSocket *pSocket, int nErrorCode)
{
	if( nErrorCode == SOCKET_ERROR ) return;
	ASSERT(pSocket);
	BYTE    bf[8192];
	UINT    n;
	TCPD	*tp;

	try{
		n = pSocket->Receive(bf, sizeof(bf));
	}
	catch(...){
		n = SOCKET_ERROR;
	}
	if( n != SOCKET_ERROR ){
		m_TcpFifo.Write(bf, n);
		while( (tp = m_TcpFifo.GetData())!=NULL ){
			switch(tp->Type){
				case cmdInOpen:
					ASSERT(tp->len == sizeof(m_InData));
					if( memcmp(&m_InData, tp->pData, sizeof(m_InData)) ){
						memcpy(&m_InData, tp->pData, sizeof(m_InData));
                        InitWFX(&m_InData);
                    }
					m_ReadStatus = TRUE;
					m_FifoRx.Clear();
					m_InStatus = m_Wave.InOpen(&m_WFX, m_SoundPara.m_ID, m_InData.size);
                    DispSoundStat();
					break;
                case cmdInClose:
					m_Wave.InClose();
                    m_InStatus = -1;
                    DispSoundStat();
                	break;
                case cmdOutOpen:
					ASSERT(tp->len == sizeof(m_OutData));
					if( memcmp(&m_OutData, tp->pData, sizeof(m_OutData)) ){
						memcpy(&m_OutData, tp->pData, sizeof(m_OutData));
                        InitWFX(&m_OutData);
                    }
					m_WriteStatus = TRUE;
                    m_FifoTx.Clear();
					m_OutStatus = m_Wave.OutOpen(&m_WFX, m_SoundPara.m_ID, m_OutData.size);
                    DispSoundStat();
                	break;
                case cmdOutAbort:
					m_Wave.OutAbort();
					m_OutStatus = -1;
                    DispSoundStat();
                	break;
                case cmdOutFlush:
					m_Wave.OutFlush();
                	break;
                case cmdOutWrite:
					if( !m_Wave.IsOutOpen() && m_OutData.size ){
						m_WriteStatus = TRUE;
    	                m_FifoTx.Clear();
						m_OutStatus = m_Wave.OutOpen(&m_WFX, m_SoundPara.m_ID, m_OutData.size);
            	        DispSoundStat();
                    }
					m_FifoTx.PutData((SHORT *)tp->pData, m_OutData.size);
					while( !m_Wave.IsOutBufFull()  && m_FifoTx.GetCount() ){
    	            	if( !m_Wave.OutWrite(m_FifoTx.GetRP()) ){
                        	m_WriteStatus = FALSE;
							WriteError();
                        }
						m_FifoTx.IncRP();
        	        }
   	                SendCounter();
                	break;
                case cmdSetOutCounter:
					m_Wave.m_OutBCC = *(LONG *)tp->pData;
   	                SendCounter();
                	break;
                case cmdPTT:
					SetPTT( *(LONG *)tp->pData );
                	break;
			}
			m_TcpFifo.DeleteData(tp);
		}
	}
}
//---------------------------------------------------------------------------
void CWLServerDlg::DispStatus(void)
{
	char bf[128];
	POSITION pos;

	COLORREF col;
	if( !m_pSocket ){
		wsprintf(bf, "CSocket class creation failed (Port=%u)", m_PortTCP);
		col = RGB(255,0,0);
	}
	else if( m_Connection.GetCount() && ((pos = m_Connection.GetHeadPosition()) !=NULL) ){
		CCSocket *pSocket = (CCSocket *)m_Connection.GetAt(pos);
		CString address;
		UINT	port;
		pSocket->GetSockName(address, port);
		wsprintf(bf, "TCP : Connected to %s", address);
		col = RGB(0,255,0);
	}
	else {
		char host[256];
		gethostname(host, sizeof(host));
		wsprintf(bf, "TCP : Listening(%s)...  (Port=%u)", host, m_PortTCP);
		col = RGB(255,255,0);
	}
	m_csDlgNStatus.SetWindowText(bf, col);
}
//---------------------------------------------------------------------------
void CWLServerDlg::DispSoundStat(void)
{
	CWnd *pSound = GetDlgItem(IDC_SOUND);
	if( (m_OutStatus >= 0) || (m_InStatus >= 0) ){
		CMD_OPEN *op = NULL;
		if( m_OutData.size ) op = &m_OutData;
		if( m_InData.size ) op = &m_InData;
		char bf[64];
		wsprintf(bf, "Sound (%uHz, %uW)", op->sampfreq, op->size);
		pSound->SetWindowText(bf);
	}
	else {
		pSound->SetWindowText("Sound");
	}

	COLORREF clBack = GetBackColor();
	COLORREF col = clBack;
	if( !m_OutStatus || !m_InStatus ){
		col = RGB(255,0,0);
	}
	else if( (m_OutStatus > 0) || (m_InStatus > 0) ){
		col = RGB(0,255,0);
	}
	m_csDlgDevID.SetWindowText("DeviceID", col);
	if( m_OutStatus >= 0 ){
		col = m_WriteStatus ? RGB(0,255,0) : RGB(255,0,0);
	}
	else {
		col = clBack;
	}
	m_csDlgTX.SetWindowText("TxFIFO", col);
	if( m_InStatus >= 0 ){
		col = m_ReadStatus ? RGB(0,255,0) : RGB(255,0,0);
	}
	else {
		col = clBack;
	}
	m_csDlgRX.SetWindowText("RxFIFO", col);
}
//---------------------------------------------------------------------------
void CWLServerDlg::CloseSocket(CCSocket *pSocket)
{
	ASSERT(pSocket);
	pSocket->EnableEvent(FALSE);
	pSocket->Close();

	POSITION pos, cur;
	for( pos = m_Connection.GetHeadPosition(); pos != NULL; ){
		cur = pos;
		CCSocket *p = (CCSocket*)m_Connection.GetNext(pos);
		if( p == pSocket ){
			m_Connection.RemoveAt(cur);
			break;
		}
	}
	delete pSocket;
	DispStatus();
}
//---------------------------------------------------------------------------
BOOL CWLServerDlg::SendBuf(CCSocket *pSocket, LPVOID p, int n)
{
#define	MEASURE		FALSE

#if MEASURE
	TRACE("Send %4d ", n);
#endif
	DWORD dwTimeOut = ::GetTickCount() + STIMEOUT;
	int len;
	do {
		len = pSocket->Send(p, n);
#if MEASURE
		TRACE("%4d ", len);
#endif
		if( len == n ){
#if MEASURE
			TRACE("done(%d).\n", STIMEOUT - dwTimeOut + ::GetTickCount());
#endif
			return TRUE;
		}
		else if( len == SOCKET_ERROR ){
			break;
		}
		else if( len < n ){
			n -= len;
			p = LPBYTE(p)+len;
		}
		::Sleep(10);
	} while( dwTimeOut > ::GetTickCount() );
	TRACE("failed(%d).\n", STIMEOUT - dwTimeOut + ::GetTickCount());
	CloseSocket(pSocket);
	return FALSE;
}
//---------------------------------------------------------------------------
BOOL CWLServerDlg::SendClient(LPVOID p, int len)
{
	POSITION pos;
	for( pos = m_Connection.GetHeadPosition(); pos != NULL; ){
		CCSocket *pSocket = (CCSocket*)m_Connection.GetNext(pos);
		if( !SendBuf(pSocket, p, len) ) return FALSE;
	}
    return TRUE;
}
//---------------------------------------------------------------------------
BOOL CWLServerDlg::SendClient(int cmd, LPVOID p, int len)
{
	if( !m_Connection.GetCount() ) return TRUE;

	BYTE *pb = new BYTE[sizeof(TCPH) + len];
	TCPH *pHead = (TCPH *)pb;
	MakeTCPH(pHead, cmd, len);
	if( len ) memcpy(pb + sizeof(TCPH), p, len);
	int r = SendClient(pb, sizeof(TCPH)+len);
	delete pb;
	return r;
}
//---------------------------------------------------------------------------
void CWLServerDlg::SetPTT(int sw)
{
	m_ptt = sw;
	if( m_hPort != INVALID_HANDLE_VALUE ){
		::EscapeCommFunction(m_hPort, (sw && m_DlgDTR) ? SETDTR : CLRDTR);
		::EscapeCommFunction(m_hPort, (sw && m_DlgRTS) ? SETRTS : CLRRTS);
    }
	m_tbDlgTX.SetState(sw);
}
//---------------------------------------------------------------------------
void CWLServerDlg::InitWFX(const CMD_OPEN *pOpen)
{
	m_WFX.wFormatTag = WAVE_FORMAT_PCM;
	m_WFX.nChannels = 1;
	m_WFX.wBitsPerSample = 16;
	m_WFX.nSamplesPerSec = pOpen->sampfreq;
	m_WFX.nBlockAlign = WORD(m_WFX.nChannels *(m_WFX.wBitsPerSample/8));
	m_WFX.nAvgBytesPerSec = m_WFX.nBlockAlign * m_WFX.nSamplesPerSec;
	m_WFX.cbSize = 0;
}
//---------------------------------------------------------------------------
void CWLServerDlg::WriteError(void)
{
	m_Wave.OutAbort();
	m_OutStatus = m_Wave.OutOpen(&m_WFX, m_SoundPara.m_ID, m_OutData.size);
	if( m_OutStatus && m_FifoTx.GetCount() ){
		if( !m_Wave.OutWrite(m_FifoTx.GetRP()) ) m_WriteStatus = FALSE;
		m_FifoTx.IncRP();
	}
	DispSoundStat();
}
//---------------------------------------------------------------------------
void CWLServerDlg::SendCounter(void)
{
	m_Counter.Max = m_Wave.m_OutFifoSize;
    m_Counter.Remaining = (m_OutStatus > 0) ? m_Wave.m_OutBC + m_FifoTx.GetCount() : m_Wave.m_OutFifoSize;
    m_Counter.Counter = m_Wave.m_OutBCC;
    SendClient(retCounter, &m_Counter, sizeof(m_Counter));
}
//---------------------------------------------------------------------------
void CWLServerDlg::OpenPort(void)
{
	COLORREF col = GetBackColor();
	switch(OpenPort_()){
		case 1:
			m_tbDlgTX.EnableWindow(TRUE);
			col = RGB(0,255,0);
			break;
		case 2:
			m_tbDlgTX.EnableWindow(FALSE);
			break;
		default:
			m_tbDlgTX.EnableWindow(FALSE);
			col = RGB(255,0,0);
			break;
	}
	m_csDlgPort.SetWindowText("Port", col);
	SetPTT(m_ptt);
}
//---------------------------------------------------------------------------
LONG CWLServerDlg::OpenPort_(void)
{
	ClosePort();
	CString pname = _tPORT[m_DlgPort];
	if( pname == "NONE" ) return 2;

	m_hPort = ::CreateFile( pname,
					GENERIC_READ | GENERIC_WRITE,
					0, NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,
					NULL
	);
	if( m_hPort == INVALID_HANDLE_VALUE ) return FALSE;
	if( ::SetupComm( m_hPort, DWORD(256), DWORD(2) ) == FALSE ){
		::CloseHandle(m_hPort);
		m_hPort = INVALID_HANDLE_VALUE;
		return FALSE;
	}
	::PurgeComm( m_hPort, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR );

	COMMTIMEOUTS TimeOut;

	TimeOut.ReadIntervalTimeout = 0xffffffff;
	TimeOut.ReadTotalTimeoutMultiplier = 0;
	TimeOut.ReadTotalTimeoutConstant = 0;
	TimeOut.WriteTotalTimeoutMultiplier = 0;
	TimeOut.WriteTotalTimeoutConstant = 20000;
	if( !::SetCommTimeouts( m_hPort, &TimeOut ) ){
		::CloseHandle( m_hPort );
		m_hPort = INVALID_HANDLE_VALUE;
		return FALSE;
	}
	DCB dcb;
	::GetCommState( m_hPort, &dcb );
	dcb.BaudRate = 9600;
	dcb.ByteSize = 8;
	dcb.StopBits = ONESTOPBIT;
	dcb.fBinary = TRUE;
	dcb.Parity = NOPARITY;
	dcb.XonChar = 0x11;	// XON
	dcb.XoffChar = 0x13;	// XOFF
	dcb.fParity = 0;
	dcb.fOutxCtsFlow = FALSE;
	dcb.fInX = dcb.fOutX = FALSE;
	dcb.fOutxDsrFlow = FALSE;
	dcb.EvtChar = 0x0d;
	dcb.fRtsControl = RTS_CONTROL_DISABLE;
	dcb.fDtrControl = DTR_CONTROL_DISABLE;
	dcb.fTXContinueOnXoff = FALSE;
	dcb.XonLim = USHORT(256/4);
	dcb.XoffLim = USHORT(256*3/4);
	dcb.DCBlength = sizeof( DCB );

	if( !::SetCommState( m_hPort, &dcb ) ){
		::CloseHandle( m_hPort );
		m_hPort = INVALID_HANDLE_VALUE;
		return FALSE;
	}

	if( !::SetCommMask( m_hPort, EV_RXFLAG ) ){
		::CloseHandle(m_hPort);
		m_hPort = INVALID_HANDLE_VALUE;
		return FALSE;
	}
	return 1;
}
//---------------------------------------------------------------------------
void CWLServerDlg::ClosePort(void)
{
	if( m_hPort != INVALID_HANDLE_VALUE ){
		::CloseHandle( m_hPort );
		m_hPort = INVALID_HANDLE_VALUE;
	}
}
//---------------------------------------------------------------------------
LRESULT CWLServerDlg::OnWaveEvent(WPARAM wParam, LPARAM lParam)
{
	switch(wParam){
		case MMWV_IN:
			{
				int err = 0;
				while( m_Wave.m_InBC && m_Wave.IsInOpen() ){
					if( !m_Wave.InRead(m_FifoRx.GetWP()) ) m_ReadStatus = FALSE;
					if( m_ReadStatus ){
						if( !err && SendClient(retRead, m_FifoRx.GetRP(), m_InData.size*sizeof(SHORT)) ){
							m_FifoRx.IncRP();
        				}
						else {
							err++;
						}
					}
					else {
						m_Wave.InClose();
						m_InStatus = m_Wave.InOpen(&m_WFX, m_SoundPara.m_ID, m_InData.size);
						DispSoundStat();
					}
				}
            }
			break;
        case MMWV_OUT:
			while( m_Wave.IsOutOpen() && m_FifoTx.GetCount() && !m_Wave.IsOutBufFull() ){
				SHORT *rp = m_FifoTx.GetRP();
               	if( !m_Wave.OutWrite(rp) ){
                	m_WriteStatus = FALSE;
					WriteError();
                }
                m_FifoTx.IncRP();

            }
            SendCounter();
        	break;
		case MMWV_PTT:
			SetPTT(m_ptt);
			break;
    }
	return TRUE;
}
//---------------------------------------------------------------------------
LRESULT CWLServerDlg::OnSocketEvent(WPARAM wParam, LPARAM lParam)
{
	switch(wParam){
		case MMSO_STATUS:
			DispStatus();
			break;
		case MMSO_CLOSE:
			ASSERT(lParam);
			CloseSocket((CCSocket*)lParam);
			break;
    }
	return TRUE;
}
//---------------------------------------------------------------------------
void CWLServerDlg::UpdateSoundPara(void)
{
    m_Wave.InClose();
    m_Wave.OutAbort();

	UpdateData(TRUE);
	m_SoundPara.m_ID = _tDevID[m_DlgDevID];
	m_SoundPara.m_TxFifo = _tFIFO[m_DlgTXFIFO];
	m_SoundPara.m_RxFifo = _tFIFO[m_DlgRXFIFO];
	m_SoundPara.m_Channel = m_DlgChannel;

    m_ReadStatus = m_WriteStatus = TRUE;
	m_Wave.m_InFifoSize = m_SoundPara.m_RxFifo;
	m_Wave.m_OutFifoSize = m_SoundPara.m_TxFifo;
	m_Wave.m_SoundStereo = m_SoundPara.m_Channel;

    if( m_InStatus >= 0 ) m_InStatus = m_Wave.InOpen(&m_WFX, m_SoundPara.m_ID, m_InData.size);
    if( m_OutStatus >= 0 ) m_OutStatus = m_Wave.OutOpen(&m_WFX, m_SoundPara.m_ID, m_OutData.size);
    DispSoundStat();
}
//---------------------------------------------------------------------------
void CWLServerDlg::OnSelchangeDevID() 
{
	UpdateSoundPara();
}
void CWLServerDlg::OnSelchangeRxfifo() 
{
	UpdateSoundPara();
}
void CWLServerDlg::OnSelchangeTxfifo() 
{
	UpdateSoundPara();
}
void CWLServerDlg::OnRmono() 
{
	UpdateSoundPara();
}
void CWLServerDlg::OnRleft() 
{
	UpdateSoundPara();
}
void CWLServerDlg::OnRright() 
{
	UpdateSoundPara();
}
void CWLServerDlg::OnDtr() 
{
	UpdateData(TRUE);
	SetPTT(m_ptt);
}
void CWLServerDlg::OnRts() 
{
	UpdateData(TRUE);
	SetPTT(m_ptt);
}
void CWLServerDlg::OnBtx() 
{
	m_ptt = m_ptt ? FALSE : TRUE;
	PostMessage(WM_WAVE, MMWV_PTT, 0);
}
void CWLServerDlg::OnSelchangePort() 
{
	UpdateData(TRUE);
	OpenPort();
}
void CWLServerDlg::OnMinimize() 
{
	if( m_DlgMinimized.GetCheck() ){
		ShowWindow(SW_MINIMIZE);
	}
}
